<?php

// Backend only

class DFDebug_Admin {
	// Reference back to $dfdebug global.
	var $dfdebug = null;

	function __construct( $parent = null ) {
		if ( $parent )
			$this->dfdebug = $parent;

		add_action( 'admin_init',      array( &$this, 'admin_init' ) );
		add_action( 'admin_menu',      array( &$this, 'admin_menu' ) );
		add_action( 'in_admin_footer', array( &$this, 'show_times' ) );
		add_action( 'in_admin_footer', array( &$this, 'memory_peak_usage' ) );

	}

	function admin_init() {
		$this->settings_fields();
	}

	function admin_menu() {
		$callback = array( &$this, 'get_admin_page' );
		add_menu_page( 'Debug Tools', 'Debug Tools', '', 'dfdebug-menu' );
		add_submenu_page( 'dfdebug-menu', 'Settings', 'Settings', 'manage_options', 'dfdebug-admin', $callback );
		add_submenu_page( 'dfdebug-menu', 'User Options', 'User Options', 'read', 'dfdebug-user-options', $callback );
	}

	function register_settings() {
		// Register only when necessary. Options page?
		// List of options and defaults should be defined in the core since they'll be read there.
	}

	function settings_fields() {
		add_settings_section( 'global', 'Global Settings', '__return_false', 'dfdebug-admin' );
		add_settings_field( 'dfdebug-enabled', 'Enabled', array( &$this, 'settings_field_output' ), 'dfdebug-admin', 'global' );
	}

	function settings_fields_section() {
		echo 'section!';
	}

	function settings_field_output() {
		echo 'field';
	}

	// Admin page callback
	function get_admin_page() {
		$path = dirname( __FILE__ );
		$page = !empty( $_REQUEST['page'] ) ? $_REQUEST['page'] : '';

		switch ( $page ) {
			case 'dfdebug-admin':
			case 'dfdebug-user-options':
				require( $path . '/page_' . $page . '.php' );
				break;
			default:
				echo 'Unknown page.';
		}
	}

	function show_times() {
		$times = timer_stop();
		echo "<p>Total time: $times sec</p>";
	}

	function memory_peak_usage() {
		$mem = $this->dfdebug->peak_memory_mb();
		echo "<p>Max memory: $mem MB</p>";
	}


}